// src/backend/dynamic_sub_request.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef DYNAMIC_SUB_REQUEST_HH
#define DYNAMIC_SUB_REQUEST_HH 1

#include "config.h"
#include "sub_request.hh"
#include "dynamic_resource.hh"
#include "static_sub_request.hh"

#include "smartp.hh"

namespace sgpem
{
  class DynamicSubRequest;
  class SerializeVisitor;
  class Resource;
  class StaticSubRequest;

  class DynamicSubRequest : public SubRequest
  {
  public:
    DynamicSubRequest(StaticSubRequest* core, DynamicResource* resource);

    DynamicResource& get_resource();

    unsigned int get_places() const;

    unsigned int get_length() const;

    int get_queue_position() const;
    void set_queue_position(int position);

    void serialize(SerializeVisitor& translator) const;

  private:
    memory::smart_ptr<StaticSubRequest> _static_subrequest;
    DynamicResource* _dynamic_resource;
    int _queue_position;
  };

}

#endif

